NXOpen .NET Reference Guide  1899
 All Classes Namespaces Functions Variables Enumerations Enumerator Properties
Public Types | Public Member Functions | Properties | List of all members
NXOpen.Features.StudioSplineBuilderEx Class Reference

Studio Spline builder class. More...

Inheritance diagram for NXOpen.Features.StudioSplineBuilderEx:
NXOpen.Features.FeatureBuilder NXOpen.Builder NXOpen.TaggedObject NXOpen.GeometricUtilities.IComponentBuilder NXOpen.Utilities.NXRemotableObject IMessageSink NXOpen.Features.DraftingSplineBuilder NXOpen.Features.SketchSplineBuilder

Public Types

enum  DrawingPlaneOptions {
  View, XY, YZ, XZ,
  General
}
 Drawing plane options More...
 
enum  InputCurveOptions { Keep, Hide, Delete }
 Options of the actions to be taken on an input non-parametric spline after its editing is done. More...
 
enum  MatchKnotsTypes { None, Cubic, General }
 Options for creating knots at the defining points in case of through point spline More...
 
enum  MovementMethodType {
  WCS, View, Vector, Plane,
  Normal, Polygon
}
 Points movement types More...
 
enum  Types { ThroughPoints, ByPoles }
 Spline methods. More...
 
enum  WCSOptionType {
  X, Y, Z, YZ,
  XZ, XY
}
 WCS principal axis or plane types More...
 

Public Member Functions

unsafe void EditSpline (NXOpen.NXObject spline)
 Sets a non-parametric spline for editing More...
 
unsafe void Evaluate ()
 Evaluates the spline More...
 
unsafe double[] GetKnots ()
 Queries the knot sequence for by pole spline More...
 
unsafe double[] GetParameters ()
 Queries the parameters at defining points for a through point spline More...
 
unsafe void InsertKnot (NXOpen.Point3d point)
 Inserts knot at a closest point on the spline More...
 
unsafe void InsertPole (int afterIndex)
 Inserts a pole in the middle of a control polygon segment More...
 
unsafe void SetKnots (double[] knots)
 Sets the optional knot sequence for by pole spline More...
 
unsafe void SetParameters (double[] parameters)
 Sets the optional parameters at defining points for a through point spline More...
 
unsafe void UpdateOnConstraintPlane ()
 Updates spline based on constraint plane More...
 
- Public Member Functions inherited from NXOpen.Features.FeatureBuilder
unsafe NXOpen.Features.Feature CommitFeature ()
 Commits the feature parameters and creates the feature More...
 
unsafe NXOpen.Features.Feature GetFeature ()
 Returns the feature currently being edited by this builder. More...
 
unsafe void HideInternalParentFeatureAfterEdit (NXOpen.Features.Feature parentFeature)
 Re-suppress an internal parent feature (a slave feature) after it has been edited. More...
 
unsafe void SetParentFeatureInternal (NXOpen.Features.Feature parentFeature)
 Set the parent features which would be internal or slaves to the feature being created or commited More...
 
unsafe void ShowInternalParentFeatureForEdit (NXOpen.Features.Feature parentFeature)
 Unsuppress an internal parent feature (a slave feature) so it can be edited. More...
 
unsafe void UnsetParentFeatureInternal (NXOpen.Features.Feature parentFeature)
 Set the internal parent feature of the feature being edited to external More...
 
- Public Member Functions inherited from NXOpen.Builder
unsafe NXOpen.NXObject Commit ()
 Commits any edits that have been applied to the builder. More...
 
unsafe void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
unsafe NXOpen.NXObject[] GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
unsafe NXOpen.NXObject GetObject ()
 Returns the object currently being edited by this builder. More...
 
unsafe void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
unsafe bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen.TaggedObject
void PrintTestData (String variableName)
 <exclude> More...
 
void PrintTestData (String variableName, int lineNumber)
 <exclude> More...
 
override string ToString ()
 Returns a String that represents the current Object. More...
 
- Public Member Functions inherited from NXOpen.Utilities.NXRemotableObject
IMessageCtrl AsyncProcessMessage (IMessage msg, IMessageSink replySink)
 Asynchronously processes the given message. More...
 
IMessage SyncProcessMessage (IMessage msg)
 Synchronously processes the given message. More...
 

Properties

unsafe bool CanUseOrientationTool [get, set]
 Returns or sets the flag indicating if WCS like tool should be deployed when a point or pole handle is selected More...
 
unsafe
NXOpen.Features.GeometricConstraintDataManager 
ConstraintManager [get]
 Returns the constraint manager. More...
 
unsafe NXOpen.CoordinateSystem ConstraintPlane [get, set]
 Returns or sets the coordinate system defining plane constraint More...
 
unsafe NXOpen.Spline Curve [get]
 Returns the spline curve More...
 
unsafe int Degree [get, set]
 Returns or sets the degree More...
 
unsafe NXOpen.Plane DrawingPlane [get, set]
 Returns or sets the drawing plane More...
 
unsafe
NXOpen.Features.StudioSplineBuilderEx.DrawingPlaneOptions 
DrawingPlaneOption [get, set]
 Returns or sets a drawing plane option More...
 
unsafe
NXOpen.GeometricUtilities.SplineExtensionBuilder 
Extender [get]
 Returns the extension option More...
 
unsafe bool HasPlaneConstraint [get, set]
 Returns or sets the flag indicating if spline has plane constraint More...
 
unsafe bool HasProportionalUpdate [get, set]
 Returns or sets the flag indicating if free or non attached defining points or poles should be moved proportionally during update of the spline feature More...
 
unsafe
NXOpen.Features.StudioSplineBuilderEx.InputCurveOptions 
InputCurveOption [get, set]
 Returns or sets the input curve option More...
 
unsafe bool IsAssociative [get, set]
 Returns or sets the flag indicating if a feature should be created More...
 
unsafe bool IsPeriodic [get, set]
 Returns or sets the periodicity More...
 
unsafe bool IsSingleSegment [get, set]
 Returns or sets a flag indicating if single segment by pole spline is to be created More...
 
unsafe
NXOpen.Features.StudioSplineBuilderEx.MatchKnotsTypes 
MatchKnotsType [get, set]
 Returns or sets a constraint to match knots at the defining points for a through point spline More...
 
unsafe
NXOpen.Features.StudioSplineBuilderEx.MovementMethodType 
MovementMethod [get, set]
 Returns or sets the movement method More...
 
unsafe NXOpen.Plane MovementPlane [get, set]
 Returns or sets the movement plane More...
 
unsafe NXOpen.Direction MovementVector [get, set]
 Returns or sets the movement vector More...
 
unsafe
NXOpen.GeometricUtilities.OrientXpressBuilder 
OrientExpress [get]
 Returns the orient express object More...
 
unsafe
NXOpen.Features.StudioSplineBuilderEx.Types 
Type [get, set]
 Returns or sets the spline method More...
 
unsafe
NXOpen.Features.StudioSplineBuilderEx.WCSOptionType 
WCSOption [get, set]
 Returns or sets the WCS option More...
 
- Properties inherited from NXOpen.Features.FeatureBuilder
unsafe bool ParentFeatureInternal [get, set]
 Returns or sets whether or not the latest timestamped parent feature of this feature should be made internal More...
 
- Properties inherited from NXOpen.Builder
unsafe NXOpen.PreviewBuilder PreviewBuilder [get]
 Returns the preview builder subobject. More...
 
- Properties inherited from NXOpen.TaggedObject
Tag Tag [get]
 Returns the tag of this object. More...
 
- Properties inherited from NXOpen.Utilities.NXRemotableObject
IMessageSink NextSink [get]
 Gets the next message sink in the sink chain. More...
 

Additional Inherited Members

- Protected Member Functions inherited from NXOpen.TaggedObject
new void initialize ()
 <exclude> More...
 

Detailed Description

Studio Spline builder class.

To create a new instance of this class, use NXOpen.Features.FeatureCollection.CreateStudioSplineBuilderEx

Default values.

Property Value

DrawingPlaneOption

View

Extender.EndExtensionOption

None

Extender.EndValue.Value

0 (millimeters part), 0 (inches part)

Extender.StartExtensionOption

None

Extender.StartValue.Value

0 (millimeters part), 0 (inches part)

InputCurveOption

Hide

MatchKnotsType

None

MovementMethod

View

Type

ThroughPoints

WCSOption

X

Created in NX8.0.0

Member Enumeration Documentation

Drawing plane options

Enumerator
View 

View plane

XY 

XY plane

YZ 

YZ plane

XZ 

XZ plane

General 

General plane

Options of the actions to be taken on an input non-parametric spline after its editing is done.

These options are used only while trying to make non-parametric spline a feature.

Enumerator
Keep 

Keep original curve

Hide 

Hide original curve

Delete 

Delete original curve

Options for creating knots at the defining points in case of through point spline

Enumerator
None 

No knot matching

Cubic 

Match knots for cubic non-periodic spline

General 

Match knots for general spline

Points movement types

Enumerator
WCS 

Movement along WCS principal axis or plane

View 

Movement in view plane

Vector 

Movement along arbitrary direction

Plane 

Movement in arbitrary plane

Normal 

Movement along a face normal

Polygon 

Movement along a relevant control polygon segment

Spline methods.

Enumerator
ThroughPoints 

Spline through points

ByPoles 

Spline by poles

WCS principal axis or plane types

Enumerator
X 

Along X axis

Y 

Along Y axis

Z 

Along Z axis

YZ 

In YZ plane

XZ 

In XZ plane

XY 

In XY plane

Member Function Documentation

unsafe void NXOpen.Features.StudioSplineBuilderEx.EditSpline ( NXOpen.NXObject  spline)
inline

Sets a non-parametric spline for editing

Created in NX8.0.0

License requirements: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
spline
unsafe void NXOpen.Features.StudioSplineBuilderEx.Evaluate ( )
inline

Evaluates the spline

Created in NX8.0.0

License requirements: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe double [] NXOpen.Features.StudioSplineBuilderEx.GetKnots ( )
inline

Queries the knot sequence for by pole spline

Created in NX8.0.0

License requirements: None.

Returns
The knot sequence
unsafe double [] NXOpen.Features.StudioSplineBuilderEx.GetParameters ( )
inline

Queries the parameters at defining points for a through point spline

Created in NX8.0.0

License requirements: None.

Returns
The parameters
unsafe void NXOpen.Features.StudioSplineBuilderEx.InsertKnot ( NXOpen.Point3d  point)
inline

Inserts knot at a closest point on the spline

Created in NX8.0.0

License requirements: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
pointPoint at which knot to be inserted
unsafe void NXOpen.Features.StudioSplineBuilderEx.InsertPole ( int  afterIndex)
inline

Inserts a pole in the middle of a control polygon segment

Created in NX8.0.0

License requirements: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
afterIndexIndex of a pole after which to insert new pole
unsafe void NXOpen.Features.StudioSplineBuilderEx.SetKnots ( double[]  knots)
inline

Sets the optional knot sequence for by pole spline

Created in NX8.0.0

License requirements: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
knotsThe knot sequence
unsafe void NXOpen.Features.StudioSplineBuilderEx.SetParameters ( double[]  parameters)
inline

Sets the optional parameters at defining points for a through point spline

Created in NX8.0.0

License requirements: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
parametersThe parameters
unsafe void NXOpen.Features.StudioSplineBuilderEx.UpdateOnConstraintPlane ( )
inline

Updates spline based on constraint plane

Created in NX8.0.0

License requirements: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

Property Documentation

unsafe bool NXOpen.Features.StudioSplineBuilderEx.CanUseOrientationTool
getset

Returns or sets the flag indicating if WCS like tool should be deployed when a point or pole handle is selected

Created in NX8.5.1

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Features.GeometricConstraintDataManager NXOpen.Features.StudioSplineBuilderEx.ConstraintManager
get

Returns the constraint manager.

Constraint manager allows user to define points or poles (G0) and assign constraints such as tangent(G1), curvature(G2) and flow(G3). The constraint objects are derived from NXOpen.SmartObject . E.g. Point constraint is of type NXOpen.Point or tangent constraint is of type NXOpen.Direction . These constraint objects are owned by the features. Thus the life span of the constraints is exactly same as the feature. When referencing objects from other features, user should always create an associative copy. E.g. when referencing a point of a NXOpen.Features.PointFeature , user should create another NXOpen.Point that references point of NXOpen.Features.PointFeature .

Created in NX8.0.0

License requirements: None.

unsafe NXOpen.CoordinateSystem NXOpen.Features.StudioSplineBuilderEx.ConstraintPlane
getset

Returns or sets the coordinate system defining plane constraint

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Spline NXOpen.Features.StudioSplineBuilderEx.Curve
get

Returns the spline curve

Created in NX8.0.0

License requirements: None.

unsafe int NXOpen.Features.StudioSplineBuilderEx.Degree
getset

Returns or sets the degree

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Plane NXOpen.Features.StudioSplineBuilderEx.DrawingPlane
getset

Returns or sets the drawing plane

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Features.StudioSplineBuilderEx.DrawingPlaneOptions NXOpen.Features.StudioSplineBuilderEx.DrawingPlaneOption
getset

Returns or sets a drawing plane option

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.GeometricUtilities.SplineExtensionBuilder NXOpen.Features.StudioSplineBuilderEx.Extender
get

Returns the extension option

Created in NX8.0.0

License requirements: None.

unsafe bool NXOpen.Features.StudioSplineBuilderEx.HasPlaneConstraint
getset

Returns or sets the flag indicating if spline has plane constraint

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe bool NXOpen.Features.StudioSplineBuilderEx.HasProportionalUpdate
getset

Returns or sets the flag indicating if free or non attached defining points or poles should be moved proportionally during update of the spline feature

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Features.StudioSplineBuilderEx.InputCurveOptions NXOpen.Features.StudioSplineBuilderEx.InputCurveOption
getset

Returns or sets the input curve option

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe bool NXOpen.Features.StudioSplineBuilderEx.IsAssociative
getset

Returns or sets the flag indicating if a feature should be created

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe bool NXOpen.Features.StudioSplineBuilderEx.IsPeriodic
getset

Returns or sets the periodicity

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe bool NXOpen.Features.StudioSplineBuilderEx.IsSingleSegment
getset

Returns or sets a flag indicating if single segment by pole spline is to be created

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Features.StudioSplineBuilderEx.MatchKnotsTypes NXOpen.Features.StudioSplineBuilderEx.MatchKnotsType
getset

Returns or sets a constraint to match knots at the defining points for a through point spline

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Features.StudioSplineBuilderEx.MovementMethodType NXOpen.Features.StudioSplineBuilderEx.MovementMethod
getset

Returns or sets the movement method

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Plane NXOpen.Features.StudioSplineBuilderEx.MovementPlane
getset

Returns or sets the movement plane

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Direction NXOpen.Features.StudioSplineBuilderEx.MovementVector
getset

Returns or sets the movement vector

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.GeometricUtilities.OrientXpressBuilder NXOpen.Features.StudioSplineBuilderEx.OrientExpress
get

Returns the orient express object

Created in NX8.0.0

License requirements: None.

unsafe NXOpen.Features.StudioSplineBuilderEx.Types NXOpen.Features.StudioSplineBuilderEx.Type
getset

Returns or sets the spline method

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")

unsafe NXOpen.Features.StudioSplineBuilderEx.WCSOptionType NXOpen.Features.StudioSplineBuilderEx.WCSOption
getset

Returns or sets the WCS option

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: features_modeling ("FEATURES MODELING") OR cam_base ("CAM BASE") OR geometric_tol ("GDT") OR insp_programming ("INSPECTION PROGRAMMING")


The documentation for this class was generated from the following file:
Copyright 2019 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.